-- Locale
local BonesINV_Locale = {
	[1]  = "Searching stopped.",
	[2]  = "\124cFFFF0000Error:\124r Invite permissions lost.",
	[3]  = "Finished searching.",
	[4]  = "\124cFFFF0000Error:\124r You do not have invite permissions.",
	[5]  = "Starting search. Recruiting levels",
	[6]  = "\124cFFFF0000Error:\124r Invites and messages disabled.",
	[7]  = "Minimum recruitment level changed to: ",
	[8]  = "Maximum recruitment level changed to: ",
	[9]  = "\124cFFFF0000Error:\124r Invalid level value.",
	[10] = "\124cFFFF0000Error:\124r Minimum level must be lower than maximum level.",
	[11] = "\124cFFFF0000Error:\124r Maximum level must be higher than minimum level.",
	[12] = "Recruitment level range: ",
	[13] = "Invite message successfully added.",
	[14] = "\124cFFFF0000Error:\124r Message length cannot exceed 255 characters.",
	[15] = "\124cFFFF0000Error:\124r No message detected.",
	[16] = "Invite message successfully removed.",
	[17] = "The invite message list is empty.",
	[18] = "\124cFFFF0000Error:\124r Only numerical values may be used.",
	[19] = "Invite Messages: \124cff00ff00Enabled\124r",
	[20] = "Invite Messages: \124cffff0000Disabled\124r",
	[21] = "Guild Invites: \124cff00ff00Enabled\124r",
	[22] = "Guild Invites: \124cffff0000Disabled\124r",
	[23] = "The invite list has been successfully reset.",
	[24] = "The invite list is empty.",
	[25] = "\124cFFFF0000Error:\124r Stop the search before changing options.",
	[26] = "\124cFFFF0000Error:\124r Stop the search before resetting the invite list.",
};

local BonesINV_BaseHelp = {
	[1] = "/ginv \124cff00ff00<command>\124r <options>",
	[2] = "\nCommand List\n",
	[3] = "     \124cff00ff00start: \124rStart the recruitment search engine.",
	[4] = "     \124cff00ff00stop: \124rStop the recruitment search engine.",
	[5] = "     \124cff00ff00level: \124rAdjust or display the levels for recruitment.",
	[6] = "     \124cff00ff00messages: \124rDisplay, toggle, delete, or add invite messages.",
	[7] = "     \124cff00ff00invites: \124rDisplay or toggle guild invites.",
	[8] = "     \124cff00ff00reset: \124rResets the list of previously invited players.",
	[9] = "     \124cff00ff00help: \124rDisplay this command list.",
}

local BonesINV_LevelHelp = {
	[1] = "/ginv level \124cff00ff00<command>\124r <options>",
	[2] = "\nCommand List\n",
	[3] = "     \124cff00ff00min: \124rAdjust the minimum recruitment level.",
	[4] = "     \124cff00ff00max: \124rAdjust the maximum recruitment level.",
	[5] = "     \124cff00ff00show: \124rDisplay the recruitment level range.",
	[6] = "     \124cff00ff00help: \124rDisplay this command list.",
}

local BonesINV_MessagesHelp = {
	[1]  = "/ginv messages \124cff00ff00<command>\124r",
	[2]  = "\nCommand List\n",
	[3]  = "     \124cff00ff00add: \124rAdd an invite message.",
	[4]  = "     \124cff00ff00del: \124rDelete an invite message.",
	[5]  = "     \124cff00ff00list: \124rDisplay all invite messages.",
	[6]  = "     \124cff00ff00show: \124rDisplay an invite message by its list number.",
	[7]  = "     \124cff00ff00status: \124rDisplay invite message status.",
	[8]  = "     \124cff00ff00enable: \124rTurn invite messages on.",
	[9]  = "     \124cff00ff00disable: \124rTurn invite messages off.",
	[10] = "     \124cff00ff00toggle: \124rToggle invite messages on and off.",
	[11] = "     \124cff00ff00help: \124rDisplay this command list.",
}

local BonesINV_InvitesHelp = {
	[1] = "/ginv invites \124cff00ff00<command>\124r",
	[2] = "\nCommand List\n",
	[3] = "     \124cff00ff00status: \124rDisplay guild invite status.",
	[4] = "     \124cff00ff00enable: \124rTurn guild invites on.",
	[5] = "     \124cff00ff00disable: \124rTurn guild invites off.",
	[6] = "     \124cff00ff00toggle: \124rToggle guild invites on and off.",
	[7] = "     \124cff00ff00help: \124rDisplay this command list.",
}
-- /Locale

-- Default Variables
function BonesINV_OnLoad()
	if not BonesINV_Message then
		BonesINV_Message = {
		};
	end
	if not BonesINV_NoInvite then
		BonesINV_NoInvite = {
		};
	end
	if not BonesINV_MessageOnInvite then
		BonesINV_MessageOnInvite = 0;
	end
	if not BonesINV_ActuallyInvite then
		BonesINV_ActuallyInvite = 1;
	end
	if not BonesINV_LevelMin then
		BonesINV_LevelMin = 1;
	end
	if not BonesINV_LevelStop then
		BonesINV_LevelStop = 85;
	end
end

BonesINV_Searching = false;
BonesINV_RaceSearch = false;
BonesINV_ClassSearch = false;
BonesINV_LastRace = 1;
BonesINV_LastClass = 1;
BonesINV_LastSearchTime = 0;
BonesINV_LevelStart = BonesINV_LevelMin;
-- /Default Variables

-- Class and Race Tables
local Classes = {
	"Priest", 
	"Warrior", 
	"Warlock", 
	"Druid", 
	"Rogue", 
	"Mage", 
	"Hunter", 
	"Paladin", 
	"Shaman", 
	"Death Knight",
};
local HordeRaces = {
	"Undead", 
	"Orc", 
	"Troll", 
	"Blood Elf", 
	"Tauren", 
	"Goblin",
};
local AllianceRaces = {
	"Gnome", 
	"Human", 
	"Night Elf", 
	"Draenei", 
	"Dwarf", 
	"Worgen",
};
-- /Class and Race Tables

-- Help Functions
function BonesINV_BaseHelpShow()
	for i = 1, #BonesINV_BaseHelp, 1 do
		print(BonesINV_BaseHelp[i]);
	end
end
function BonesINV_MessagesHelpShow()
	for i = 1, #BonesINV_MessagesHelp, 1 do
		print(BonesINV_MessagesHelp[i]);
	end
end
function BonesINV_InvitesHelpShow()
	for i = 1, #BonesINV_InvitesHelp, 1 do
		print(BonesINV_InvitesHelp[i]);
	end
end
function BonesINV_LevelHelpShow()
	for i = 1, #BonesINV_LevelHelp, 1 do
		print(BonesINV_LevelHelp[i]);
	end
end
-- /Help Functions

-- /Invite Functions
function BonesINV_InvitePerson(CharName, GuildName)
	for i = 1, #BonesINV_NoInvite, 1 do
		if CharName == BonesINV_NoInvite[i] then
			return;
		end
	end
	if GuildName == "" then
		if BonesINV_MessageOnInvite == 1 and #BonesINV_Message > 0 then
			SendChatMessage(BonesINV_Message[random(1,#BonesINV_Message)], "WHISPER", nil, CharName);
		end
		if BonesINV_ActuallyInvite == 1 then
			GuildInvite(CharName);
		end
		BonesINV_NoInvite[#BonesINV_NoInvite + 1] = CharName;
	end
end

function BonesINV_InviteWhoResults()
	local WhoNum = GetNumWhoResults();
	for i = 1, WhoNum, 1 do
		CharName, GuildName = GetWhoInfo(i);
		BonesINV_InvitePerson(CharName, GuildName)
	end
end
-- Invite Functions

-- OnEvent Function
function BonesINV_OnEvent()
	if not BonesINV_Searching then 
		return; 
	end
	local WhoNum = GetNumWhoResults();
	if BonesINV_RaceSearch then
		if BonesINV_ClassSearch then
			BonesINV_LastClass = BonesINV_LastClass + 1;
			if Classes[BonesINV_LastClass] == nil then
				BonesINV_ClassSearch = false;
				BonesINV_LastRace = BonesINV_LastRace + 1;
				if HordeRaces[BonesINV_LastRace] == nil then
					BonesINV_RaceSearch = false;
					BonesINV_LevelStart = BonesINV_LevelStart + 1;
				end
			end
		else
			if WhoNum >= 50 then
				BonesINV_LastClass = 1;
				BonesINV_ClassSearch = true;
				return;
			end
			BonesINV_LastRace = BonesINV_LastRace + 1;
			if HordeRaces[BonesINV_LastRace] == nil then
				BonesINV_RaceSearch = false;
				BonesINV_LevelStart = BonesINV_LevelStart + 1;
			end
		end
	else
		if WhoNum >= 50 then
			BonesINV_LastRace = 1;
			BonesINV_RaceSearch = true;
			return;
		else
			BonesINV_RaceSearch = false;
			BonesINV_LevelStart = BonesINV_LevelStart + 1;
		end
	end
	BonesINV_InviteWhoResults();
end
-- /OnEvent Function

-- Who Function
function BonesINV_SendSearch()
	SetWhoToUI(1);
	FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE");
	BonesINV_WhoString = BonesINV_LevelStart.." g-\"\"";
	if BonesINV_RaceSearch then
		if (UnitFactionGroup("player") == "Horde") then
			BonesINV_WhoString = BonesINV_WhoString.." r-\""..HordeRaces[BonesINV_LastRace];
		else
			BonesINV_WhoString = BonesINV_WhoString.." r-\""..AllianceRaces[BonesINV_LastRace];
		end
		BonesINV_WhoString = BonesINV_WhoString.. "\""; 
	end
	if BonesINV_ClassSearch then
		BonesINV_WhoString = BonesINV_WhoString.." c-\""..Classes[BonesINV_LastClass].."\"";
	end
	BonesINV_Searching = true;
	BonesINV_LastSearchTime = time();
	SendWho(BonesINV_WhoString);
end
-- /Who Function

-- Start Search
function BonesINV_StartSearch()
	BonesINV_Frame:RegisterEvent("WHO_LIST_UPDATE");
	if not CanGuildInvite() then
		print(BonesINV_Locale[4]);
		return;
	end
	if BonesINV_MessageOnInvite + BonesINV_ActuallyInvite == 0 then
		print(BonesINV_Locale[6]);
		return;
	end
	BonesINV_RaceSearch = false;
	BonesINV_ClassSearch = false;
	BonesINV_LevelStart = BonesINV_LevelMin;
	print(BonesINV_Locale[5].." "..BonesINV_LevelStart .. " - " ..BonesINV_LevelStop);
	BonesINV_SendSearch();
end
-- /Start Search	

-- Stop Search
function BonesINV_StopSearch()
	BonesINV_Searching = false;
	FriendsFrame:RegisterEvent("WHO_LIST_UPDATE");
	BonesINV_Frame:UnregisterEvent("WHO_LIST_UPDATE");
	SetWhoToUI(0);
	print(BonesINV_Locale[1]);
end
-- /Stop Search

-- OnUpdate Function
function BonesINV_OnUpdate()
	if BonesINV_Searching and time() > BonesINV_LastSearchTime + 5 then
		if not CanGuildInvite() then
			print(BonesINV_Locale[2]);
			BonesINV_StopSearch();
		elseif BonesINV_LevelStart <= BonesINV_LevelStop then
			BonesINV_SendSearch();
		else
			BonesINV_StopSearch();
			print(BonesINV_Locale[3]);
		end
	end
end
-- /OnUpdate Function

-- Level Adjust Functions
function BonesINV_ChangeMinLevel(input)
	if not BonesINV_Searching then
		if tonumber(input) then
			if tonumber(input) <= 85 and tonumber(input) >= 1 then
				if tonumber(input) <= BonesINV_LevelStop then		
					BonesINV_LevelMin = tonumber(input);
					print(BonesINV_Locale[7].."\124cff00ff00"..tonumber(input).."\124r");
				else
					print(BonesINV_Locale[10]);
				end
			else
				print(BonesINV_Locale[9]);
			end
		else
			print(BonesINV_Locale[9]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_ChangeMaxLevel(input)
	if not BonesINV_Searching then
		if tonumber(input) then
			if tonumber(input) <= 85 and tonumber(input) >= 1 then
				if tonumber(input) >= BonesINV_LevelMin then		
					BonesINV_LevelStop = tonumber(input);
					print(BonesINV_Locale[8].."\124cff00ff00"..tonumber(input).."\124r");
				else
					print(BonesINV_Locale[11]);
				end
			else
				print(BonesINV_Locale[9]);
			end
		else
			print(BonesINV_Locale[9]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end
-- /Level Adjust Functions

-- New Invite Message
function BonesINV_InviteMessageAdd(input)
	if not BonesINV_Searching then
		if input then
			if #input <= 255 then
				BonesINV_Message[#BonesINV_Message + 1] = input
				print('\124cff00ff00"\124r'..input..'\124cff00ff00"\124r');
				print(BonesINV_Locale[13]);
			else
				print(BonesINV_Locale[14]);
			end
		else
			print(BonesINV_Locale[15]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end
-- /New Invite Message

-- Remove Message Function
function BonesINV_InviteMessageRemove(input)
	if not BonesINV_Searching then
		if input then
			for i = 1, #BonesINV_Message, 1 do
				if BonesINV_Message[i] == input then
					print('\124cffff0000"\124r'..BonesINV_Message[i]..'\124cffff0000"\124r');
					table.remove(BonesINV_Message, i);
					print(BonesINV_Locale[16]);
					return
				end	
			end
			if tonumber(input) then
				if tonumber(input) >= 1 and tonumber(input) <= #BonesINV_Message then
					print('\124cffff0000"\124r'..BonesINV_Message[tonumber(input)]..'\124cffff0000"\124r');
					table.remove(BonesINV_Message, input);
					print(BonesINV_Locale[16]);
					return
				end
			else
				print(BonesINV_Locale[15]);
			end		
		else
			print(BonesINV_Locale[15]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end
-- /Remove Message Function

-- Message List Function
function BonesINV_InviteMessageShow()
	for i = 1, #BonesINV_Message, 1 do
		print("\124cff00ff00"..i..': "\124r'..BonesINV_Message[i]..'\124cff00ff00"\124r');
	end
	if #BonesINV_Message == 0 then
		print(BonesINV_Locale[17]);
	end
end
-- /Message List Function

-- Message Number List Function
function BonesINV_InviteMessageNumberShow(input)
	if tonumber(input) then
		if BonesINV_Message[tonumber(input)] then
			print("\124cff00ff00"..input..': "\124r'..BonesINV_Message[tonumber(input)]..'\124cff00ff00"\124r');
		else
			print(BonesINV_Locale[15]);
		end
	else
		print(BonesINV_Locale[18]);
	end
end
-- /Message Number List Function

-- Status Toggle Function
function BonesINV_InviteMessageStatus()
	if not BonesINV_Searching then 
		if BonesINV_MessageOnInvite == 1 then
			print(BonesINV_Locale[19]);
		else
			print(BonesINV_Locale[20]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_InviteMessageEnable()
	if not BonesINV_Searching then
		BonesINV_MessageOnInvite = 1;
		print(BonesINV_Locale[19]);
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_InviteMessageDisable()
	if not BonesINV_Searching then
		BonesINV_MessageOnInvite = 0;
		print(BonesINV_Locale[20]);
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_InviteMessageToggle()
	if not BonesINV_Searching then
		if BonesINV_MessageOnInvite == 1 then
			BonesINV_MessageOnInvite = 0;
			print(BonesINV_Locale[20]);
		else
			BonesINV_MessageOnInvite = 1;
			print(BonesINV_Locale[19]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end
-- /Status Toggle Function

-- Invite Status Toggle Function
function BonesINV_InviteStatus()
	if BonesINV_ActuallyInvite == 1 then
		print(BonesINV_Locale[21]);
	else
		print(BonesINV_Locale[22]);
	end
end

function BonesINV_InviteEnable()
	if not BonesINV_Searching then
		BonesINV_ActuallyInvite = 1;
		print(BonesINV_Locale[21]);
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_InviteDisable()
	if not BonesINV_Searching then
		BonesINV_ActuallyInvite = 0;
		print(BonesINV_Locale[22]);
	else
		print(BonesINV_Locale[25]);
	end
end

function BonesINV_InviteToggle()
	if not BonesINV_Searching then
		if BonesINV_ActuallyInvite == 1 then
			BonesINV_ActuallyInvite = 0;
			print(BonesINV_Locale[22]);
		else
			BonesINV_ActuallyInvite = 1;
			print(BonesINV_Locale[21]);
		end
	else
		print(BonesINV_Locale[25]);
	end
end
-- /Invite Status Toggle Function

-- Reset
function BonesINV_Reset()
	if not BonesINV_Searching then
		if #BonesINV_NoInvite >= 1 then
			for i = 1, #BonesINV_NoInvite, 1 do
				table.remove(BonesINV_NoInvite, i);
			end
			print(BonesINV_Locale[23]);
		else
			print(BonesINV_Locale[24]);
		end
	else
		print(BonesINV_Locale[26]);
	end
end
-- /Reset

-- Slash Commands
BonesINV_CommandTable = {
	["start"] = function() 
		BonesINV_StartSearch();
	end,
	["stop"] = function() 
		BonesINV_StopSearch();
	end,
	["level"] = {
		["min"] = function(input)
			BonesINV_ChangeMinLevel(input);
		end,
		["max"] = function(input)
			BonesINV_ChangeMaxLevel(input);
		end,
		["show"] = function()
			print(BonesINV_Locale[12].."\124cff00ff00"..BonesINV_LevelMin.."\124r - \124cff00ff00"..BonesINV_LevelStop.."\124r");
		end,
		["help"] = function()
			BonesINV_LevelHelpShow();
		end,
	},
	["messages"] = {
		["add"] = function(input)
			BonesINV_InviteMessageAdd(input);
		end,
		["del"] = function(input)
			BonesINV_InviteMessageRemove(input);
		end,
		["list"] = function()
			BonesINV_InviteMessageShow();
		end,
		["show"] = function(input)
			BonesINV_InviteMessageNumberShow(input);
		end,
		["status"] = function()
			BonesINV_InviteMessageStatus();
		end,
		["enable"] = function()
			BonesINV_InviteMessageEnable();
		end,
		["disable"] = function()
			BonesINV_InviteMessageDisable();
		end,
		["toggle"] = function()
			BonesINV_InviteMessageToggle();
		end,		
		["help"] = function()
			BonesINV_MessagesHelpShow();
		end,
	},
	["invites"] = {
		["status"] = function()
			BonesINV_InviteStatus();
		end,
		["enable"] = function()
			BonesINV_InviteEnable();
		end,
		["disable"] = function()
			BonesINV_InviteDisable();
		end,
		["toggle"] = function()
			BonesINV_InviteToggle();
		end,
		["help"] = function()
			BonesINV_InvitesHelpShow();
		end,
	},
	["reset"] = function()
		BonesINV_Reset();
	end,
	["help"] = function()
		BonesINV_BaseHelpShow();
	end,
}

function BonesINV_DispatchCommand(input, commandTable)
	local command, parameters = string.split(" ", input, 2)
	local entry = commandTable[command:lower()]
	local which = type(entry)
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		BonesINV_DispatchCommand(parameters or " ", entry)
	elseif which == "string" then
		print(entry)
	elseif message ~= "help" then
		BonesINV_DispatchCommand("help", commandTable)
	end
end

SLASH_GINV1 = "/ginv"
SLASH_GINV2 = "/ginv"
SlashCmdList["GINV"] = function(input)
	BonesINV_DispatchCommand(input,  BonesINV_CommandTable)
end
-- /Slash Commands